Index: /trunk/src/VBox/Frontends/VirtualBox/src/manager/tools/UIToolsItem.cpp
===================================================================
--- /trunk/src/VBox/Frontends/VirtualBox/src/manager/tools/UIToolsItem.cpp	(revision 89242)
+++ /trunk/src/VBox/Frontends/VirtualBox/src/manager/tools/UIToolsItem.cpp	(revision 89243)
@@ -189,10 +189,10 @@
     , m_iHoveredValue(100)
     , m_iAnimatedValue(m_iDefaultValue)
-    , m_iDefaultLightnessMin(0)
-    , m_iDefaultLightnessMax(0)
-    , m_iHoverLightnessMin(0)
-    , m_iHoverLightnessMax(0)
-    , m_iHighlightLightnessMin(0)
-    , m_iHighlightLightnessMax(0)
+    , m_iDefaultLightnessStart(0)
+    , m_iDefaultLightnessFinal(0)
+    , m_iHoverLightnessStart(0)
+    , m_iHoverLightnessFinal(0)
+    , m_iHighlightLightnessStart(0)
+    , m_iHighlightLightnessFinal(0)
     , m_iPreviousMinimumWidthHint(0)
     , m_iPreviousMinimumHeightHint(0)
@@ -443,17 +443,17 @@
     /* Prepare color tones: */
 #ifdef VBOX_WS_MAC
-    m_iHighlightLightnessMin = 105;
-    m_iHighlightLightnessMax = 115;
-    m_iHoverLightnessMin = 115;
-    m_iHoverLightnessMax = 125;
-    m_iDefaultLightnessMin = 145;
-    m_iDefaultLightnessMax = 155;
+    m_iDefaultLightnessStart = 105;
+    m_iDefaultLightnessFinal = 115;
+    m_iHoverLightnessStart = 115;
+    m_iHoverLightnessFinal = 125;
+    m_iHighlightLightnessStart = 145;
+    m_iHighlightLightnessFinal = 155;
 #else /* VBOX_WS_MAC */
-    m_iHighlightLightnessMin = 130;
-    m_iHighlightLightnessMax = 160;
-    m_iHoverLightnessMin = 160;
-    m_iHoverLightnessMax = 190;
-    m_iDefaultLightnessMin = 160;
-    m_iDefaultLightnessMax = 190;
+    m_iHighlightLightnessStart = 130;
+    m_iHighlightLightnessFinal = 160;
+    m_iHoverLightnessStart = 160;
+    m_iHoverLightnessFinal = 190;
+    m_iDefaultLightnessStart = 160;
+    m_iDefaultLightnessFinal = 190;
 #endif /* !VBOX_WS_MAC */
 
@@ -720,6 +720,6 @@
         /* Draw gradient: */
         QLinearGradient bgGrad(rectangle.topLeft(), rectangle.bottomLeft());
-        bgGrad.setColorAt(0, backgroundColor.lighter(m_iHighlightLightnessMax));
-        bgGrad.setColorAt(1, backgroundColor.lighter(m_iHighlightLightnessMin));
+        bgGrad.setColorAt(0, backgroundColor.lighter(m_iHighlightLightnessFinal));
+        bgGrad.setColorAt(1, backgroundColor.lighter(m_iHighlightLightnessStart));
         pPainter->fillRect(rectangle, bgGrad);
 
@@ -759,6 +759,6 @@
         /* Draw gradient: */
         QLinearGradient bgGrad(rectangle.topLeft(), rectangle.bottomLeft());
-        bgGrad.setColorAt(0, backgroundColor.lighter(m_iHoverLightnessMax));
-        bgGrad.setColorAt(1, backgroundColor.lighter(m_iHoverLightnessMin));
+        bgGrad.setColorAt(0, backgroundColor.lighter(m_iHoverLightnessFinal));
+        bgGrad.setColorAt(1, backgroundColor.lighter(m_iHoverLightnessStart));
         pPainter->fillRect(rectangle, bgGrad);
 
@@ -798,6 +798,6 @@
         /* Draw gradient: */
         QLinearGradient bgGrad(rectangle.topLeft(), rectangle.bottomLeft());
-        bgGrad.setColorAt(0, backgroundColor.lighter(m_iDefaultLightnessMax));
-        bgGrad.setColorAt(1, backgroundColor.lighter(m_iDefaultLightnessMin));
+        bgGrad.setColorAt(0, backgroundColor.lighter(m_iDefaultLightnessFinal));
+        bgGrad.setColorAt(1, backgroundColor.lighter(m_iDefaultLightnessStart));
         pPainter->fillRect(rectangle, bgGrad);
     }
@@ -822,11 +822,11 @@
     /* Selection frame: */
     if (model()->currentItem() == this)
-        strokeColor = pal.color(QPalette::Active, QPalette::Highlight).lighter(m_iHighlightLightnessMin - 40);
+        strokeColor = pal.color(QPalette::Active, QPalette::Highlight).lighter(m_iHighlightLightnessStart - 40);
     /* Hovering frame: */
     else if (isHovered())
-        strokeColor = pal.color(QPalette::Active, QPalette::Highlight).lighter(m_iHoverLightnessMin - 50);
+        strokeColor = pal.color(QPalette::Active, QPalette::Highlight).lighter(m_iHoverLightnessStart - 40);
     /* Default frame: */
     else
-        strokeColor = pal.color(QPalette::Active, QPalette::Mid).lighter(m_iDefaultLightnessMin);
+        strokeColor = pal.color(QPalette::Active, QPalette::Mid).lighter(m_iDefaultLightnessStart);
 
     /* Create/assign pen: */
@@ -862,6 +862,6 @@
         const QColor highlight = pal.color(QPalette::Active, QPalette::Highlight);
         const QColor background = model()->currentItem() == this
-                                ? highlight.lighter(m_iHighlightLightnessMin)
-                                : highlight.lighter(m_iHoverLightnessMin);
+                                ? highlight.lighter(m_iHighlightLightnessStart)
+                                : highlight.lighter(m_iHoverLightnessStart);
 
         /* Get foreground color: */
Index: /trunk/src/VBox/Frontends/VirtualBox/src/manager/tools/UIToolsItem.h
===================================================================
--- /trunk/src/VBox/Frontends/VirtualBox/src/manager/tools/UIToolsItem.h	(revision 89242)
+++ /trunk/src/VBox/Frontends/VirtualBox/src/manager/tools/UIToolsItem.h	(revision 89243)
@@ -289,16 +289,16 @@
         int                 m_iAnimatedValue;
 
-        /** Holds minimum default lightness tone. */
-        int  m_iDefaultLightnessMin;
-        /** Holds maximum default lightness tone. */
-        int  m_iDefaultLightnessMax;
-        /** Holds minimum hover lightness tone. */
-        int  m_iHoverLightnessMin;
-        /** Holds maximum hover lightness tone. */
-        int  m_iHoverLightnessMax;
-        /** Holds minimum highlight lightness tone. */
-        int  m_iHighlightLightnessMin;
-        /** Holds maximum highlight lightness tone. */
-        int  m_iHighlightLightnessMax;
+        /** Holds start default lightness tone. */
+        int  m_iDefaultLightnessStart;
+        /** Holds final default lightness tone. */
+        int  m_iDefaultLightnessFinal;
+        /** Holds start hover lightness tone. */
+        int  m_iHoverLightnessStart;
+        /** Holds final hover lightness tone. */
+        int  m_iHoverLightnessFinal;
+        /** Holds start highlight lightness tone. */
+        int  m_iHighlightLightnessStart;
+        /** Holds final highlight lightness tone. */
+        int  m_iHighlightLightnessFinal;
     /** @} */
 