Index: trunk/src/VBox/Frontends/VirtualBox/src/manager/chooser/UIChooserItemGlobal.cpp
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/manager/chooser/UIChooserItemGlobal.cpp	(revision 89248)
+++ trunk/src/VBox/Frontends/VirtualBox/src/manager/chooser/UIChooserItemGlobal.cpp	(revision 89249)
@@ -32,6 +32,8 @@
 UIChooserItemGlobal::UIChooserItemGlobal(UIChooserItem *pParent, UIChooserNodeGlobal *pNode)
     : UIChooserItem(pParent, pNode)
-    , m_iDefaultLightnessStart(0)
-    , m_iDefaultLightnessFinal(0)
+#ifdef VBOX_WS_MAC
+    , m_iDefaultDarknessStart(0)
+    , m_iDefaultDarknessFinal(0)
+#endif
     , m_iHoverLightnessStart(0)
     , m_iHoverLightnessFinal(0)
@@ -328,19 +330,22 @@
 {
     /* Color tones: */
-#ifdef VBOX_WS_MAC
-    m_iDefaultLightnessStart = 130;
-    m_iDefaultLightnessFinal = 125;
+#if defined(VBOX_WS_MAC)
+    m_iDefaultDarknessStart = 105;
+    m_iDefaultDarknessFinal = 115;
     m_iHoverLightnessStart = 125;
     m_iHoverLightnessFinal = 115;
     m_iHighlightLightnessStart = 115;
     m_iHighlightLightnessFinal = 105;
-#else /* VBOX_WS_MAC */
-    m_iDefaultLightnessStart = 190;
-    m_iDefaultLightnessFinal = 160;
+#elif defined(VBOX_WS_WIN)
     m_iHoverLightnessStart = 190;
     m_iHoverLightnessFinal = 160;
     m_iHighlightLightnessStart = 160;
     m_iHighlightLightnessFinal = 130;
-#endif /* !VBOX_WS_MAC */
+#else /* !VBOX_WS_MAC && !VBOX_WS_WIN */
+    m_iHoverLightnessStart = 190;
+    m_iHoverLightnessFinal = 160;
+    m_iHighlightLightnessStart = 160;
+    m_iHighlightLightnessFinal = 130;
+#endif /* !VBOX_WS_MAC && !VBOX_WS_WIN */
 
     /* Fonts: */
@@ -634,15 +639,13 @@
 #ifdef VBOX_WS_MAC
         /* Prepare color: */
-        const QColor backgroundColor = pal.color(QPalette::Active, QPalette::Mid);
+        const QColor backgroundColor = pal.color(QPalette::Active, QPalette::Window);
         /* Draw gradient: */
         QLinearGradient bgGrad(rectangle.topLeft(), rectangle.bottomLeft());
-        bgGrad.setColorAt(0, backgroundColor.lighter(m_iDefaultLightnessStart));
-        bgGrad.setColorAt(1, backgroundColor.lighter(m_iDefaultLightnessFinal));
+        bgGrad.setColorAt(0, backgroundColor.darker(m_iDefaultDarknessStart));
+        bgGrad.setColorAt(1, backgroundColor.darker(m_iDefaultDarknessFinal));
         pPainter->fillRect(rectangle, bgGrad);
 #else
-        /* Prepare color: */
-        QColor backgroundColor = pal.color(QPalette::Active, QPalette::Mid).lighter(160);
-        /* Draw gradient: */
-        pPainter->fillRect(rectangle, backgroundColor);
+        /* Draw simple background: */
+        pPainter->fillRect(rectangle, pal.color(QPalette::Active, QPalette::Window));
 #endif
     }
Index: trunk/src/VBox/Frontends/VirtualBox/src/manager/chooser/UIChooserItemGlobal.h
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/manager/chooser/UIChooserItemGlobal.h	(revision 89248)
+++ trunk/src/VBox/Frontends/VirtualBox/src/manager/chooser/UIChooserItemGlobal.h	(revision 89249)
@@ -219,8 +219,10 @@
     /** @name Item stuff.
       * @{ */
-        /** Holds item start default lightness. */
-        int  m_iDefaultLightnessStart;
-        /** Holds item final default lightness. */
-        int  m_iDefaultLightnessFinal;
+#ifdef VBOX_WS_MAC
+        /** Holds item start default darkness. */
+        int  m_iDefaultDarknessStart;
+        /** Holds item final default darkness. */
+        int  m_iDefaultDarknessFinal;
+#endif
         /** Holds item start hover lightness. */
         int  m_iHoverLightnessStart;
Index: trunk/src/VBox/Frontends/VirtualBox/src/manager/chooser/UIChooserItemGroup.cpp
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/manager/chooser/UIChooserItemGroup.cpp	(revision 89248)
+++ trunk/src/VBox/Frontends/VirtualBox/src/manager/chooser/UIChooserItemGroup.cpp	(revision 89249)
@@ -50,6 +50,7 @@
     , m_iRootBackgroundDarknessStart(0)
     , m_iRootBackgroundDarknessFinal(0)
+    , m_iItemBackgroundDarknessStart(0)
+    , m_iItemBackgroundDarknessFinal(0)
     , m_iAdditionalHeight(0)
-    , m_iHeaderDarkness(0)
     , m_pToggleButton(0)
     , m_pNameEditorWidget(0)
@@ -72,6 +73,7 @@
     , m_iRootBackgroundDarknessStart(0)
     , m_iRootBackgroundDarknessFinal(0)
+    , m_iItemBackgroundDarknessStart(0)
+    , m_iItemBackgroundDarknessFinal(0)
     , m_iAdditionalHeight(0)
-    , m_iHeaderDarkness(0)
     , m_pToggleButton(0)
     , m_pNameEditorWidget(0)
@@ -1048,5 +1050,6 @@
     m_iRootBackgroundDarknessStart = 115;
     m_iRootBackgroundDarknessFinal = 150;
-    m_iHeaderDarkness = 110;
+    m_iItemBackgroundDarknessStart = 100;
+    m_iItemBackgroundDarknessFinal = 105;
 
     /* Prepare self: */
@@ -1611,34 +1614,36 @@
     else
     {
-        /* Prepare color: */
-        const QColor backgroundColor = QApplication::palette().color(QPalette::Active,
-                                                                     model()->selectedItems().contains(this) ?
-                                                                     QPalette::Highlight : QPalette::Window);
-
-        /* Prepare variables: */
-        const int iMarginV = data(GroupItemData_MarginV).toInt();
-        const int iFullHeaderHeight = 2 * iMarginV + m_minimumHeaderSize.height();
-
-        /* Calculate top rectangle: */
-        QRect tRect = rect;
-        if (nodeToGroupType()->isOpened())
-            tRect.setBottom(tRect.top() + iFullHeaderHeight - 1);
-
-        /* Prepare top gradient: */
-        QLinearGradient tGradient(tRect.bottomLeft(), tRect.topLeft());
-        tGradient.setColorAt(1, backgroundColor.lighter(100 + (double)animatedValue() / 100 * 30));
-        tGradient.setColorAt(0, backgroundColor);
-
-        /* Fill top rectangle: */
-        pPainter->fillRect(tRect, tGradient);
-
-        /* Calculate bottom rectangle: */
-        if (nodeToGroupType()->isOpened())
-        {
-            QRect bRect = rect;
-            bRect.setTop(bRect.top() + iFullHeaderHeight);
-
-            /* Fill top rectangle: */
-            pPainter->fillRect(bRect, backgroundColor);
+        /* Acquire background color: */
+        const QColor backgroundColor = model()->selectedItems().contains(this)
+                                     ? QApplication::palette().color(QPalette::Active, QPalette::Highlight)
+                                     : QApplication::palette().color(QPalette::Active, QPalette::Window);
+
+        /* Paint default background: */
+        QLinearGradient gradientDefault(rect.topRight(), rect.bottomLeft());
+        gradientDefault.setColorAt(0, backgroundColor.darker(m_iItemBackgroundDarknessStart));
+        gradientDefault.setColorAt(1, backgroundColor.darker(m_iItemBackgroundDarknessFinal));
+        pPainter->fillRect(rect, gradientDefault);
+
+        /* If element is hovered: */
+        if (animatedValue())
+        {
+            /* Calculate header rectangle: */
+            const int iMarginV = data(GroupItemData_MarginV).toInt();
+            const int iFullHeaderHeight = 2 * iMarginV + m_minimumHeaderSize.height();
+            QRect headRect = rect;
+            headRect.setHeight(iFullHeaderHeight);
+
+            /* Acquire header color: */
+            QColor headColor = backgroundColor.lighter(130);
+
+            /* Paint hovered background: */
+            QColor hcTone1 = headColor;
+            QColor hcTone2 = headColor;
+            hcTone1.setAlpha(255 * animatedValue() / 100);
+            hcTone2.setAlpha(0);
+            QLinearGradient gradientHovered(headRect.topLeft(), headRect.bottomLeft());
+            gradientHovered.setColorAt(0, hcTone1);
+            gradientHovered.setColorAt(1, hcTone2);
+            pPainter->fillRect(headRect, gradientHovered);
         }
 
@@ -1689,5 +1694,5 @@
 
     /* Prepare color: */
-    const QColor frameColor = QApplication::palette().color(QPalette::Active, QPalette::Highlight).darker(headerDarkness() + 10);
+    const QColor frameColor = QApplication::palette().color(QPalette::Active, QPalette::Highlight).darker(110);
 
     /* Create/assign pen: */
@@ -1733,5 +1738,5 @@
 
         /* Get background color: */
-        const QColor background = pal.color(QPalette::Active, QPalette::Highlight).darker(headerDarkness());
+        const QColor background = pal.color(QPalette::Active, QPalette::Highlight);
 
         /* Get foreground color: */
Index: trunk/src/VBox/Frontends/VirtualBox/src/manager/chooser/UIChooserItemGroup.h
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/manager/chooser/UIChooserItemGroup.h	(revision 89248)
+++ trunk/src/VBox/Frontends/VirtualBox/src/manager/chooser/UIChooserItemGroup.h	(revision 89249)
@@ -255,7 +255,4 @@
         QVariant data(int iKey) const;
 
-        /** Returns item's header darkness. */
-        int headerDarkness() const { return m_iHeaderDarkness; }
-
         /** Returns additional height. */
         int additionalHeight() const;
@@ -328,9 +325,11 @@
         /** Holds root final background darkness. */
         int  m_iRootBackgroundDarknessFinal;
+        /** Holds item start background darkness. */
+        int  m_iItemBackgroundDarknessStart;
+        /** Holds item final background darkness. */
+        int  m_iItemBackgroundDarknessFinal;
 
         /** Holds aditional height. */
         int  m_iAdditionalHeight;
-        /** Holds the header darkness. */
-        int  m_iHeaderDarkness;
 
         /** Holds group children pixmap. */
Index: trunk/src/VBox/Frontends/VirtualBox/src/manager/chooser/UIChooserItemMachine.cpp
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/manager/chooser/UIChooserItemMachine.cpp	(revision 89248)
+++ trunk/src/VBox/Frontends/VirtualBox/src/manager/chooser/UIChooserItemMachine.cpp	(revision 89249)
@@ -545,19 +545,26 @@
 {
     /* Color tones: */
-#ifdef VBOX_WS_MAC
-    m_iDefaultLightnessStart = 155;
-    m_iDefaultLightnessFinal = 145;
+#if defined(VBOX_WS_MAC)
+    m_iDefaultLightnessStart = 120;
+    m_iDefaultLightnessFinal = 110;
     m_iHoverLightnessStart = 125;
     m_iHoverLightnessFinal = 115;
     m_iHighlightLightnessStart = 115;
     m_iHighlightLightnessFinal = 105;
-#else /* VBOX_WS_MAC */
-    m_iDefaultLightnessStart = 190;
-    m_iDefaultLightnessFinal = 160;
+#elif defined(VBOX_WS_WIN)
+    m_iDefaultLightnessStart = 120;
+    m_iDefaultLightnessFinal = 110;
     m_iHoverLightnessStart = 190;
     m_iHoverLightnessFinal = 160;
     m_iHighlightLightnessStart = 160;
     m_iHighlightLightnessFinal = 130;
-#endif /* !VBOX_WS_MAC */
+#else /* !VBOX_WS_MAC && !VBOX_WS_WIN */
+    m_iDefaultLightnessStart = 110;
+    m_iDefaultLightnessFinal = 100;
+    m_iHoverLightnessStart = 190;
+    m_iHoverLightnessFinal = 160;
+    m_iHighlightLightnessStart = 160;
+    m_iHighlightLightnessFinal = 130;
+#endif /* !VBOX_WS_MAC && !VBOX_WS_WIN */
 
     /* Fonts: */
@@ -977,5 +984,5 @@
     {
         /* Prepare color: */
-        QColor backgroundColor = pal.color(QPalette::Active, QPalette::Mid);
+        QColor backgroundColor = pal.color(QPalette::Active, QPalette::Window);
         /* Draw gradient: */
         QLinearGradient bgGrad(rectangle.topLeft(), rectangle.bottomLeft());