Index: trunk/src/VBox/Devices/Audio/AudioMixBuffer.cpp
===================================================================
--- trunk/src/VBox/Devices/Audio/AudioMixBuffer.cpp	(revision 89350)
+++ trunk/src/VBox/Devices/Audio/AudioMixBuffer.cpp	(revision 89351)
@@ -845,17 +845,4 @@
 
 /**
- * Get the number of readable frames in the buffer.
- *
- * @returns Number of frames.
- * @param   pMixBuf     The mixing buffer.
- * @todo Exactly same as AudioMixBufUsed.
- */
-uint32_t AudioMixBufLive(PCAUDIOMIXBUF pMixBuf)
-{
-    return AudioMixBufUsed(pMixBuf);
-}
-
-
-/**
  * Worker for AudioMixBufFree and AudioMixBufFreeBytes.
  */
Index: trunk/src/VBox/Devices/Audio/AudioMixBuffer.h
===================================================================
--- trunk/src/VBox/Devices/Audio/AudioMixBuffer.h	(revision 89350)
+++ trunk/src/VBox/Devices/Audio/AudioMixBuffer.h	(revision 89351)
@@ -192,5 +192,4 @@
 uint32_t    AudioMixBufUsed(PCAUDIOMIXBUF pMixBuf);
 uint32_t    AudioMixBufUsedBytes(PCAUDIOMIXBUF pMixBuf);
-uint32_t    AudioMixBufLive(PCAUDIOMIXBUF pMixBuf);
 uint32_t    AudioMixBufFree(PCAUDIOMIXBUF pMixBuf);
 uint32_t    AudioMixBufFreeBytes(PCAUDIOMIXBUF pMixBuf);
Index: trunk/src/VBox/Devices/Audio/AudioMixer.cpp
===================================================================
--- trunk/src/VBox/Devices/Audio/AudioMixer.cpp	(revision 89350)
+++ trunk/src/VBox/Devices/Audio/AudioMixer.cpp	(revision 89351)
@@ -761,5 +761,5 @@
      */
     uint32_t const cFramesDmaAndMixBuf = PDMAudioPropsBytesToFrames(&pSink->MixBuf.Props, cbDmaLeftToDrain)
-                                       + AudioMixBufLive(&pSink->MixBuf);
+                                       + AudioMixBufUsed(&pSink->MixBuf);
     uint64_t const cNsToDrainMax       = PDMAudioPropsFramesToNano(&pSink->MixBuf.Props, cFramesDmaAndMixBuf + cFramesStreamMax);
     uint64_t const nsDeadline          = cNsToDrainMax * 2;
@@ -1031,5 +1031,5 @@
     if (pSink->fStatus & AUDMIXSINK_STS_RUNNING)
     {
-        uint32_t const cFrames = AudioMixBufLive(&pSink->MixBuf);
+        uint32_t const cFrames = AudioMixBufUsed(&pSink->MixBuf);
         cbReadable = PDMAudioPropsFramesToBytes(&pSink->PCMProps, cFrames);
     }
@@ -1717,5 +1717,5 @@
 static uint32_t audioMixerSinkUpdateOutputCalcFramesToRead(PAUDMIXSINK pSink, uint32_t *pcWritableStreams)
 {
-    uint32_t      cFramesToRead    = AudioMixBufLive(&pSink->MixBuf); /* (to read from the mixing buffer) */
+    uint32_t      cFramesToRead    = AudioMixBufUsed(&pSink->MixBuf); /* (to read from the mixing buffer) */
     uint32_t      cWritableStreams = 0;
     PAUDMIXSTREAM pMixStream;
@@ -1784,5 +1784,5 @@
         || AudioMixBufFree(&pSink->MixBuf) > 2)
         Log3Func(("%s: cLiveFrames=%#x cFramesToRead=%#x cWritableStreams=%#x\n", pSink->pszName,
-                  AudioMixBufLive(&pSink->MixBuf), cFramesToRead, cWritableStreams));
+                  AudioMixBufUsed(&pSink->MixBuf), cFramesToRead, cWritableStreams));
     else
     {
@@ -1830,5 +1830,5 @@
 
         Log3Func(("%s: cLiveFrames=%#x cFramesToRead=%#x cWritableStreams=%#x cMarkedUnreliable=%#x cReliableStreams=%#x\n",
-                  pSink->pszName, AudioMixBufLive(&pSink->MixBuf), cFramesToRead,
+                  pSink->pszName, AudioMixBufUsed(&pSink->MixBuf), cFramesToRead,
                   cWritableStreams, cMarkedUnreliable, cReliableStreams));
     }
Index: trunk/src/VBox/Devices/Audio/testcase/tstAudioMixBuffer.cpp
===================================================================
--- trunk/src/VBox/Devices/Audio/testcase/tstAudioMixBuffer.cpp	(revision 89350)
+++ trunk/src/VBox/Devices/Audio/testcase/tstAudioMixBuffer.cpp	(revision 89351)
@@ -625,5 +625,5 @@
         RTTESTI_CHECK_MSG_BREAK(cSrcFrames == cSrcFramesWritten,
                                 ("cSrcFrames=%RU32 vs cSrcFramesWritten=%RU32 cLiveFrames=%RU32\n",
-                                 cSrcFrames, cSrcFramesWritten, AudioMixBufLive(&MixBuf)));
+                                 cSrcFrames, cSrcFramesWritten, AudioMixBufUsed(&MixBuf)));
         AudioMixBufCommit(&MixBuf, cSrcFrames);
 
@@ -664,5 +664,5 @@
          */
         AudioMixBufAdvance(&MixBuf, cSrcFrames);
-        RTTESTI_CHECK(AudioMixBufLive(&MixBuf) == 0);
+        RTTESTI_CHECK(AudioMixBufUsed(&MixBuf) == 0);
     }
 